/* Uwe Tangen 2007.06.11 */

/*#define TEST*/

#include "ng_biopro_external.h"


volatile int pis = -1;  /* Approximation to pi (shared) */
volatile int wait_out = 1;  /* Approximation to pi (shared) */
pthread_mutex_t pi_lock;   /* Lock for above */
int                 tcp_sockfd = -1;
int                 tcp_connfd = -1;
char p_remote[60];   /* Name of the remote machine */

struct sockaddr_in  adresse;
size_t              adrlaenge = sizeof(struct sockaddr_in);
static int img_rd = -1;
static int img_wr = -1;
static pthread_t thread0, thread1;


int com_process(void *arg)
{
    char p_com[_MAX_STRING_];           /* Command for other side       */
    char *p_b;                          /* Pointer to character         */
    int k, m;                           /* Counter for images           */
    int level;
    int last_img;                       /* Index of last image          */
    int stype; 
    int len;                            /* Length of received message   */
    int row_ctr;                        /* Image row-counter            */
    register int iproc = (*((char *) arg) - '0');
    char p_buf[_MAX_STRING_];

    level = 0;
    last_img = -1;
    row_ctr = 0;
    k = 0;
    m = 0;

    /* Do the local computations */
    switch(iproc)
    {
    case 0:
        /*----- We can wait -----*/
        printf("... Datenempfang \n");
        while(pis == -1)
        {
            stype = ng_tcp_recdata(tcp_sockfd, &len, (char **) &p_b);
            if(stype == -1) 
            {
                printf("Could not read data elements!\n");
                pis = 0;
            }
            switch(stype)
            {
            case 0:  /* Other side vanished */
            case _MSG_QUIT_:
                pis = 0;
                wait_out = 0;
                break;

            case 'y':
                /*----- Got okay from server -----*/
                if(len == 0) printf("No return parameter!\n");
                printf("Okay with session %s\n", p_b);
                wait_out = 0;
                break;

            case 's':
                /*----- Got system-state from server -----*/
                if(len == 0) printf("No return parameter!\n");
                printf("The state is return['%c']: %s\n", stype, p_b);
                wait_out = 0;
                break;

            case 'E':
                /*----- Got a pin-entry from the server -----*/
                if(len == 0) printf("No return parameter!\n");
                printf("Error: %s\n", p_b);
                wait_out = 0;
                break;

            case 'g':
                /*----- Got a geometry of a sensor from the server or -----*/
            case 'i':
                /*----- Got a sensor-value from the server -----*/
                if(len == 0) printf("No return parameter!\n");
                printf("return['%c']: %s\n", stype, p_b);
                wait_out = 0;
                break;

            case 'I':
                /*----- Got a stdout from an external program -----*/
                printf("return['%c']: %s\n", stype, p_b);
                wait_out = 1;
                break;

            case 'S':
            case 'f':
            case 'l':
            case 'x':
                /*----- Got a time-stamp from the server -----*/
                if(len == 0) printf("No return parameter!\n");
                printf("return['%c']: %s\n", stype, p_b);
                break;

            case 't':
                /*----- Got a time-stamp from the server -----*/
                if(len == 0) printf("No return parameter!\n");
                printf("\nreturn['%c']: %s\n", stype, p_b);
                break;

            case 'h':
                /*----- Got image header ------*/
                printf("Got an image header return['%c']: %s!\n", stype, p_b);
                row_ctr = 0;
                break;

            case 'p':
            case 'm':
            case 'n':
                if(len == 0) printf("No return parameter!\n");
                printf("return['%c']: %s\n", stype, p_b);
                break;

            case 'R':
                row_ctr++;
                #ifdef DEBUG_IMAGE
                {
                    int i;               /* Laufvariable                 */
                    unsigned char *p_d;  /* Intermediate buffer          */
                    unsigned short val;  /* Image value                  */
                    if(row_ctr > 80 && row_ctr < 200) 
                    {
                        printf("Got image row return['%c']: %d!\n", 
                               stype, row_ctr);
                        for(i = 180; i < 220; i++)
                        {
                            p_d = (unsigned char *) &p_b[2 * i];
                            val = (p_d[0] << 8) | p_d[1];
                            printf("0x%x ", val);
                        }
                        printf("\n");
                    }
                    else if((row_ctr % 80) == 0) printf("\n");
                    else printf(".");
                }
                #else
                    if(row_ctr < 10)
                        printf("Got image row %d!\n", row_ctr);
                    else if((row_ctr % 80) == 0) printf("\n");
                    else printf(".");

                #endif /* DEBUG_IMAGE */
                break;

            case 'r':
                /*----- Got image end -----*/
                printf("Got last line of image data return['%c']: %s "
                       "(row_ctr = %d)\n", stype, p_b, row_ctr);
                wait_out = 0;
                break;

            default:
                printf("Got type = 0x%x and str = '%s'\n", stype, p_b);
                sleep(1);
                wait_out = 0;
            }

            if(len > 0)
            {
                p_b--;
                free(p_b);
            }
        }

        printf("finished thread 0\n");
        #ifdef TAKE_TCP
            close(tcp_connfd);
        #endif /* TAKE_TCP */
        pthread_cancel(thread1);
        break;

    case 1:
        sprintf(p_buf, "%s \"%s\"", "my_session", "my comment");
        ng_tcp_senddata(tcp_sockfd, strlen(p_buf), 'o', p_buf);
        usleep(100000);
        wait_out = -1;

        do
        {
            /* printf("wait_out = %d\n", wait_out); */
            while(wait_out == 1) usleep(100000);
            printf("Command : ");
            fgets(p_com, _MAX_STRING_, stdin);
            len = strlen(p_com) - 1;
            p_com[len] = 0;
            if(toupper(p_com[0]) == 'H')
            {
                /*----- Printout some help -----*/
                printf("a {light source name} {intensity [0..63]}: Set AOTF or light-source intensity!\n");
                printf("B {cycle_type} {cycle_name} [{position}]: Begin a predefined cycle (not yet implemented)!\n");
                printf("C {name} {exposure time, camera gain etc.}: Define camera parameters!\n");
                printf("c : Close the current session!\n");
                printf("d : List all available pins (electrodes) with some of the relevant information!\n");
                printf("E {cycle-type} {name of running cycle} [ end ]: End a predefined running cycle (not yet implemented)!\n");
                printf("e {pin-ID} {-, +, z}: Apply a certain potential to an electrode!\n");
                printf("g {[pin-ID] }: Get intensity values from a certain sensors!\n");
                printf("G {cycle-type} {name of cycle}: Get status of a cycle (not yet implemented)!\n");
                printf("i : Get a single image (snap-shot)!\n");
                printf("L {list-type}: Extract a list of names of this type (not yet implemented)!\n");
                printf("l {sensor-ID}: List all data from a certain sensor!\n");
                printf("m : Show all defined measurements! (returns sensors)\n");
                printf("n {norm, active, ref} {value}: Define norm-duty, active-duty or ref. cycle in 1/10ms!\n");
                printf("o {session-name} : Open a session!\n");
                printf("p {dia, unit, flow} {value}: Define pump-paramters (dia in [mm], unit [vol/time], flow [unit]!\n");
                printf("q : Abort!\n");
                printf("r [{since, after} {time, counter}]: Get a full report on actions taken (not yet implemented)!\n");
                printf("S {cycle-type} {name}: Synchronize to an existing event or cycle!\n");
                printf("s : Get the current state of the system!\n");
                printf("T {name-of controller} {temperature in °C}: Set a certain temperature!\n");
                printf("t {name of program + parameters} : Execute a test program (not yet implemented)!\n");
                printf("u {action} {pump-nr}: Control the pumps (start, stop etc.)\n");
                printf("v : Update design-window.\n");
                printf("x {controller-name} {nr. axes} {coordinate}: Move the xy-table to a certain position\n");
                printf("y {position-name} : Move the xy-table and zStage to a certain predefined position\n");
                printf("z {controller-name} {height} : Move the zStage to a certain height [um]\n");
            }
            else
            {
                /*----- We have a normal command. -----*/
                switch(p_com[0])
                {
                case 'q':
                case 'Q':
                case 'e':
                    wait_out = 0;
                    break;
                default:
                    wait_out = 1;
                    break;
                }
                if(len > 2)
                {
                    ng_tcp_senddata(tcp_sockfd, len - 2, p_com[0], &p_com[2]);
                }
                else if(len > 0)
                {
                    ng_tcp_senddata(tcp_sockfd, 0, p_com[0], NULL);
                }
            }

            if(p_com[0] == 'q') pis = 1;
        } while(pis == -1);
        printf("finished thread 1\n");
        break;
    }

    /* Lock pi for update, update it, and unlock */
    pthread_mutex_lock(&pi_lock);
    pis = iproc;
    pthread_mutex_unlock(&pi_lock);

    return(0);
}

int main_srv(void)
{
    void * retval;

    if (pthread_create(&thread0, NULL, (void *) com_process, "0") ||
        pthread_create(&thread1, NULL, (void *) com_process, "1"))
        printf("cannot make thread\n");

    do
    {
        /* printf("img_wr = 0x%x img_rd = 0x%x pis = 0x%x\n",
               img_wr, img_rd, pis); */
        if(pis != -1) break;
        else if(img_wr == img_rd) usleep(100000);
    } while(pis == -1);


    /* Join (collapse) the two threads */
    if (pthread_join(thread0, &retval) ||
        pthread_join(thread1, &retval))  printf("thread join failed\n");

    printf("we are finished!\n");

    #ifdef TAKE_TCP
        close(tcp_sockfd);
    #endif /* TAKE_TCP */

    return(0);
}

int main(int argc, char *argv[])
{
    struct in_addr      inadr;
    struct hostent      *rechner;

    if (argc < 2) printf("usage: %s machine-id\n", argv[0]);

    /* Initialize the lock on pi */
    pthread_mutex_init(&pi_lock, NULL);

    strncpy(p_remote, argv[1], 59);

    if (inet_aton(p_remote, &inadr))
       rechner = gethostbyaddr((char *) &inadr, sizeof(inadr), AF_INET);
    else
       rechner = gethostbyname(p_remote);

    if (rechner == NULL) printf("Error, unknown host\n");

    adresse.sin_family = AF_INET;
    adresse.sin_port   = htons(TCP_PORT_NUMMER);
    memcpy(&adresse.sin_addr, rechner->h_addr_list[0],
           sizeof(adresse.sin_addr));
    if ( (tcp_sockfd = socket(PF_INET, SOCK_STREAM, 0)) < 0)
         printf("Could not open tcp-socket\n");

    if (connect(tcp_sockfd, (struct sockaddr *) &adresse, sizeof(adresse)))
        printf("Connect failed!\n");

    main_srv();

    return(0);
}
